﻿/*
 *         Progetto: Esempio di applicazione multi-thread in C#
 * 
 *           Autore: Roberto Fuligni
 *  Ultima modifica: 25/11/2018
 *  
 */

using System;
using System.Threading.Tasks;
using System.Windows;

namespace ThreadWPF18_19
{
    /// <summary>
    /// Logica di interazione per MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        const int N = 200000000;
        public MainWindow()
        {
            InitializeComponent();
        }

        private void btnEsegui_Click(object sender, RoutedEventArgs e)
        {
            Task.Factory.StartNew(EseguiElaborazione);
        }

        private void EseguiElaborazione()
        {
            int A = 0;          // Conterrà il dato di input convertito in numero
            int conteggio = 0;

            Dispatcher.Invoke(() =>
           {
               // Converte la stringa contenuta nella textbox in un numero intero.
               // Si suppone che la conversione abbia sempre successo.
               A = Convert.ToInt32(tbA.Text);

               // Inizializzazione dei controlli grafici
               btnEsegui.IsEnabled = false;
               lbConteggio.Content = "";
               pbElab.Value = 0;
           });

            for(int m = 1; m <= N; m++)
            {
                if (m % A == 0)
                    conteggio++;

                if (m % 1000000 == 0)
                {
                    // Aggiornamento della progress bar ogni milione di numeri
                    Dispatcher.Invoke(() =>
                    {
                        pbElab.Value = m;
                    });
                }

            }

            // Visualizzazione del conteggio finale e ripristino del bottone
            Dispatcher.Invoke(() =>
            {
                lbConteggio.Content = conteggio.ToString();
                btnEsegui.IsEnabled = true;
            });
        }
    }
}
